package name.panitz.util;
import java.util.Map;

public sealed interface Logic
     permits Logic.Var, Logic.Neg, Logic.Implication, Logic.And, Logic.Or{
  static record Var(String n) implements Logic{}
  static record Neg(Logic f) implements Logic{}
  static record Implication(Logic l,Logic r) implements Logic{}
  static record And(Logic l,Logic r) implements Logic{}
  static record Or(Logic l,Logic r) implements Logic{}

  default boolean evaluate(Map<String,Boolean> interpretation){
    return switch(this){
      case Var v -> interpretation.get(v.n);
      //TODO add missing cases
    };
  }
}