package name.panitz.util;
//
import org.junit.Before;
import org.junit.Test;
import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;
import static name.panitz.util.Logic.*;
import java.util.*;

public class LogicTest {
  Map<String,Boolean> i1;
  Map<String,Boolean> i2;
  Map<String,Boolean> i3;
  Map<String,Boolean> i4;
  Map<String,Boolean> i5;
  Map<String,Boolean> i6;
  Map<String,Boolean> i7;
  Map<String,Boolean> i8;

  @Before
  public void setUp() throws Exception {
    i1=new HashMap<>();
    i2=new HashMap<>();
    i3=new HashMap<>();
    i4=new HashMap<>();
    i5=new HashMap<>();
    i6=new HashMap<>();
    i7=new HashMap<>();
    i8=new HashMap<>();
    i1.put("A",true);
    i2.put("A",true);
    i3.put("A",true);
    i4.put("A",true);
    i5.put("A",false);
    i6.put("A",false);
    i7.put("A",false);
    i8.put("A",false);
    i1.put("B",true);
    i2.put("B",true);
    i3.put("B",false);
    i4.put("B",false);
    i5.put("B",true);
    i6.put("B",true);
    i7.put("B",false);
    i8.put("B",false);
    i1.put("C",true);
    i2.put("C",false);
    i3.put("C",true);
    i4.put("C",false);
    i5.put("C",true);
    i6.put("C",false);
    i7.put("C",true);
    i8.put("C",false);
  }

  @Test
  public void test1(){
    var na = new Neg(new Var("A"));
    assertFalse(na.evaluate(i1));
    assertTrue(na.evaluate(i5));
  }
  @Test
  public void test2(){
    var na = new Neg(new Neg(new Var("A")));
    assertFalse(na.evaluate(i5));
    assertTrue(na.evaluate(i1));
  }

  @Test
  public void test3(){
    var ab = new Implication(new Var("A"),new Var("B"));
    assertFalse(ab.evaluate(i3));
    assertTrue(ab.evaluate(i1));
    assertTrue(ab.evaluate(i5));
    assertTrue(ab.evaluate(i8));
  }
  @Test
  public void test4(){
    var ab = new And(new Var("A"),new Var("B"));
    assertFalse(ab.evaluate(i3));
    assertTrue(ab.evaluate(i1));
    assertFalse(ab.evaluate(i5));
    assertFalse(ab.evaluate(i8));
  }

  @Test
  public void test5(){
    var ab = new Or(new Var("A"),new Var("B"));
    assertTrue(ab.evaluate(i3));
    assertTrue(ab.evaluate(i1));
    assertTrue(ab.evaluate(i5));
    assertFalse(ab.evaluate(i8));
  }

  @Test
  public void test6(){
    var ab = new Implication(new Var("C"),new Or(new Var("A"),new Var("B")));
    assertTrue(ab.evaluate(i3));
    assertTrue(ab.evaluate(i1));
    assertTrue(ab.evaluate(i5));
    assertTrue(ab.evaluate(i8));
    assertFalse(ab.evaluate(i7));
  }


}